# Import des micro:bit Moduls
from microbit import *

# Initialisierung der I2C Schnittstelle
i2c.init(freq = 400000, sda = pin20, scl = pin19)

# Da die Funktion zfill nicht in micro:bit Micropython enthalten ist, muss diese als Funktion eingefügt werden
def zfill(s, width):
    return '{:0>{w}}'.format(s, w=width)

# IO Expander Daten auslesen und in sen_data speichern
def fetchSensorData():
    data = "{0:b}".format(ord(i2c.read(0x38, 1))) # Hexadezimaldaten auslesen und in binär umwandeln
    data = zfill(data, 8)  # die Daten ggf. auf 8 Ziffern auffüllen
    bol_data_dict = {}  # blo_data_dict als Dictionary deklarieren
    bit_count = 7  # Zähler für die Schleife, die die Daten aus data in bol_data_dict einträgt
    # Übertragung der Daten aus data in bol_data_dict
    for i in data:
        if i == "0":
            bol_data_dict[bit_count] = False
            bit_count -= 1
        else:
            bol_data_dict[bit_count] = True
            bit_count -= 1
    # Daten in die globale Variable sen_data übertragen
    return bol_data_dict  # bit 0 = SpeedLeft, bit 1 = SpeedRight, bit 2 = LineTrackerLeft, bit 3 = LineTrackerMiddle, bit 4 = LineTrackerRight, bit 5 = ObstclLeft, bit 6 = ObstclRight, bit 7 = Buzzer


# while Schleife die showSensorData mit einem Abstand von einer Sekunde ausführt und anzeigt
while True:
    sen_data = fetchSensorData()
    print("\n\naus der Variable sen_data")
    print(sen_data)
    sleep(1000)
    print("\n\ndirekt aus der Funktion fetchSensorData()")
    print(fetchSensorData())
    sleep(1000)